use strict;
use warnings;

# @W[̓ǂݍ
use Net::FTP;
use File::Spec;
use File::Copy 'move';

# A_E[ht@CۑfBNg
my $download_dir = 'c:/tmp';

# Bt@C̃_E[h
download_files($download_dir);

# Ct@CgqƂɕނfBNgɈړ
categorize_files($download_dir);

# Dt@C_E[hTu[`
sub download_files {

    # D-1 [JfBNg
    my $ldir = shift;

    # D-2 zXg
    my $host = 'ftp.riken.jp';

    # D-3 FTPT[oɐڑ
    my $ftp = Net::FTP->new($host)
      or die qq{Can't connect to "$host": $@};

    # D-4 FTPT[oփOC
    $ftp->login('anonymous')
      or die qq{Can't login "$host" } . $ftp->message;

    # D-5 _E[ht@CۑfBNg̍쐬
    mkdir $ldir unless -d $ldir;

    # D-6 [gfBNg
    my $rdir = '/lang/CPAN/';

    # D-7 [gfBNg̈ړ
    $ftp->cwd($rdir)
      or die qq{Can't change directory "$rdir" } . $ftp->message;

    # D-8 t@C̎擾
    foreach my $file ($ftp->ls) {
        
        # D-9 w肵gqɃ}b`Ȃꍇ͔΂
        next unless $file =~ /(\.html|\.gz)$/;
        
        # D-10 t@C𖼑Oĕۑ
        $ftp->get($file, File::Spec->catfile($ldir, $file))
          or die qq{Can't get file "$file" } . $ftp->message;
    }
}

# Et@CgqƂɕނfBNgɈړTu[`
sub categorize_files {

    # E-1 fBNg
    my $dir = shift;
    
    # E-2 ׂẴt@C擾
    my @files = glob(File::Spec->catfile($dir, '*'));
    @files = grep { -f $_ } @files;
    
    # E-3 t@Cgqɉĕ
    my %exts;
    foreach my $file (@files) {
    
        # E-4 gq擾
        my $ext;
        if ($file =~ /\.([^\.]+)$/) {
            $ext = $1;
        }
        
        # E-5 gqgăfBNg쐬
        my $ext_dir = File::Spec->catfile($dir, $ext);
        mkdir $ext_dir unless -d $ext_dir;
        
        # E-6 t@Cړ
        move $file, $ext_dir
          or die qq{Can't move file "$file" to "$ext_dir": $!};
    }
}